<template>
    <div v-if="displayBookmaker()"
         class="row row-thin has-subtable"
         :class="[showSubtable  ? 'show-subtable': '']"
    >
        <div class="cell cell-name">
            <div class="name-text">{{ marketName }}</div>
            <div class="bubble name-line-num">{{ line.line }}</div>
        </div>
        <div class="cell cell-odds">
            <span>{{ betsCount }}</span>
        </div>
        <div v-for="(coeff, coeffIndex) in line.coefficients" :key="coeffIndex" class="cell cell-coeff">
            <span class="bubble">{{ coeff.toFixed(2) }}</span>
        </div>
        <div class="cell cell-payout">
            <span class="percent">{{ avgPercent(line.coefficients) }}%</span>
        </div>
        <div class="cell cell-arr">
            <div class="toggle-arr" @click="showSubtable = !showSubtable">
                <svg>
                    <use xlink:href="#toggle-arr"/>
                </svg>
            </div>
        </div>

        <div class="subtable">
            <div class="subtable-head">
                <div class="cell cell-bookmaker">
                    <div class="name">Bookmaker</div>
                </div>
                <div class="cell cell-handicap">
                    <div class="name">Handicap</div>
                </div>
                <div
                    v-for="(coeffName, coeffNameIdx) in line.coefficientsGroups"
                    :key="coeffNameIdx"
                    class="cell cell-coeff"
                >
                    <div class="name">{{ coeffName }}</div>
                </div>
                <div class="cell cell-payout">
                    <div class="name">Payout</div>
                </div>
                <div class="cell cell-arr cell-empty"></div>
            </div>
            <div class="subtable-table">
                <match-table-row
                    type="sub"
                    v-for="(bookmaker, bookmakerIdx) in line.bets"
                    :key="bookmakerIdx"
                    :idx="bookmakerIdx"
                    :eventId="eventId"
                    :marketId="marketId"
                    :item="bookmaker"
                    :displayElement="true"
                />
            </div>
            <div class="stats subtable-stats">
                <div class="stats-line avg">
                    <div class="name">Average</div>
                    <div class="nums">
                        <div
                            v-for="(coeff, coeffIndex) in line.coefficients"
                            :key="coeffIndex"
                            class="num"
                        >
                            {{ coeff.toFixed(2) }}
                        </div>
                        <div class="num percent">{{ avgPercent(line.coefficients) }}%</div>
                    </div>
                </div>
                <div class="stats-line highest">
                    <div class="name">Highest</div>
                    <div class="nums">
                        <div
                            v-for="(coeffName, coeffIndex) in line.coefficientsGroups"
                            :key="coeffIndex"
                            class="num"
                        >
                            {{ highestCoeff(coeffName) }}
                        </div>
                        <div class="num percent">{{ highestPercent(line.coefficientsGroups) }}%</div>
                    </div>
                </div>
            </div>
            <div class="add-event-to-tracker subtable-tracker">
                <div class="icon"></div>
                <div class="name">Add This Event To My Tracker</div>
                <div class="buttons flex aic">
                    <button class="btn btn-small btn-white-opacity" @click="addToTracker('1')">Add</button>
                    <button class="btn btn-small btn-white-opacity" @click="addToTracker('2')">Add</button>
                    <span class="btn-close-subtable" @click="showSubtable = !showSubtable">
                        <svg><use xlink:href="#toggle-arr"/></svg>
                    </span>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import {Fragment} from 'vue-fragment'
import MatchTableRow from './MatchTableRow'
import Api from "../../../JokerApi";
import {mapActions} from "vuex";

const api = new Api
export default {
    name: 'MatchTableLine',
    props: {
        line: Object,
        displayElement: {type: Boolean},
        eventId: {
            type: [String, Number]
        },
        marketId: {
            type: Number,
        }
    },
    data() {
        return {
            showSubtable: false,
        }
    },
    computed: {
        betsCount() {
            return Object.keys(this.line.bets).length
        },
        marketName() {
            return Object.values(Object.values(this.line.bets)[0])[0].market.name
        },
        marketLine() {
            return Object.values(Object.values(this.line.bets)[0])[0].line
        }
    },
    methods: {
        ...mapActions(['setAverage']),
        avgPercent(values) {
            let itemsSum = 0;
            Object.values(values).map(el => {
                itemsSum += 1 / parseFloat(el)
            })
            return (1 / itemsSum * 100).toFixed(2)
        },
        highestPercent(coeffNames) {
            let highestCoeffs = []
            coeffNames.map(coeffName => {
                highestCoeffs.push(this.highestCoeff(coeffName))
            })

            let itemsSum = 0;
            Object.values(highestCoeffs).map(el => {
                itemsSum += 1 / parseFloat(el)
            })
            return (1 / itemsSum * 100).toFixed(2)
        },
        highestCoeff(coeffName) {
            let highest = 0
            Object.values(this.line.bets).map(bookmaker => {
                Object.entries(bookmaker).map(([cName, cData]) => {
                    if (cName === coeffName) {
                        highest = parseFloat(cData.price) > highest ? parseFloat(cData.price) : highest
                    }
                })
            })
            return highest.toFixed(2)
        },
        addToTracker(type) {
            const remember_token = this.$cookies.get('api_remember_token')
            if (this.marketId == 2) {
                let marketLineBet = this.line.base_line
                console.log(this.line.base_line)
                if (type == 1) {
                    api.addTrackerItem(remember_token, this.eventId, this.marketId, 'Over', this.line.base_line).then((res) => {
                        // this.$log.debug('addTrackerItem', type, this.marketId, this.eventId, marketLineBet, 'addToTracker', res)
                        this.setAverage({
                            marketId: type,
                            average: this.line.coefficients['Over'],
                            id: `${this.eventId}_${this.marketId}${'Over'}${marketLineBet}`
                        })


                    }).then(() => {
                        this.$root.$emit('updateTrackerItems')
                    })
                }
                    if (type == 2) {
                        api.addTrackerItem(remember_token, this.eventId, this.marketId, 'Under', this.line.base_line).then((res) => {
                            // this.$log.debug('addTrackerItem', type, this.marketId, this.eventId, marketLineBet, 'addToTracker', res)
                            this.setAverage({
                                marketId: type,
                                average: this.line.coefficients['Under'],
                                id: `${this.eventId}_${this.marketId}${'Under'}${marketLineBet}`
                            })


                        }).then(() => {
                            this.$root.$emit('updateTrackerItems')
                        })
                    }
            }
            if (this.marketId != 2) {
                api.addTrackerItem(remember_token, this.eventId, this.marketId, type, this.marketLine).then((res) => {
                    this.setAverage({
                        marketId: type,
                        average: this.line.coefficients[type],
                        id: `${this.eventId}_${this.marketId}${type}${this.marketLine}`
                    })

                }).then(() => {
                    this.$root.$emit('updateTrackerItems')
                })
            }
        },
        displayBookmaker() {
            if (this.displayElement) {
                let tmp = [];
                Object.values(this.line.bets).map((item, key) => {
                        if (item.hasOwnProperty(1)) {
                            if (item[1]['bookmaker']['active']) {
                                tmp.push(1)
                            }
                        } else if (item.hasOwnProperty('Over')) {
                            if (item['Over']['bookmaker']['active']) {
                                tmp.push(1)
                            }
                        }
                    }
                );
                return tmp.length;
            }
            let tmp = [];
            Object.values(this.line.bets).map((item, key) => {
                    if (item.hasOwnProperty(1)) {
                        if (item[1]['bookmaker']['selected'] && item[1]['bookmaker']['active']) {
                            tmp.push(1)
                        }
                    } else if (item.hasOwnProperty('Over')) {
                        if (item['Over']['bookmaker']['selected'] && item['Over']['bookmaker']['active']) {
                            tmp.push(1)
                        }
                    }
                }
            );
            return tmp.length;
            // return Object.values(Object.values(this.line.bets)[0])[0]['bookmaker'].selected
        }
    },
    mounted() {
        // this.$log.debug(this.bets)
        this.$root.$on('updateTrackerAverages', items => (
            this.$cookies.set('getAverage', items)
        ))
    },
    components: {MatchTableRow, Fragment},
    watch: {}
}
</script>

<style scoped lang="scss">
.odds-table .table .bubble {
    z-index: 0;
}
</style>
